#!/bin/sh

# mk_hex.sh (ascii EDID to Intel HEX-record convertion utility)
#
# Written by Noel Lemouel <noel.lemouel@stellae.fr>

DEFAULT_EDID="hp1740.dat"

if [ ! $# -eq 1 ]; then
	echo Usage: $0 FILE
	exit -1
fi

case "$1" in
  default)
    EDID_DAT="$DEFAULT_EDID"
    ;;
  clean)
    rm -rvf *.bin *.hex *.exe bin2hex edid edid.c
    exit 0
    ;;
  *)
    EDID_DAT="$1"
    ;;
esac

if [ ! -f "$EDID_DAT" ]; then
	echo $1 not found
	exit -1
fi

echo -e "#include <stdio.h>"'\n\n'"const unsigned char EDID[]={" > edid.c

if [ ! "$EDID_DAT" = "$DEFAULT_EDID" ]; then
	sed -e '1,3d; s/^.*|//; s/ /,0x/g; s/^,//; s/
$/,/g; $ s/,$//' "$EDID_DAT" >> edid.c
else
	cat "$EDID_DAT" >> edid.c
fi

# ^M => press Ctrl-V followed by Ctrl-M

echo -e \
"                           };"'\n'"int main()"'\n'"{"'\n'\
"   int i;"'\n\n'\
"   for(i=0; i<128; i++)"'\n'\
"   {"'\n'\
"      printf(\"%c\", EDID[i]);"'\n'\
"   }"'\n\n'\
"   return 0;"'\n'\
"}"'\n' >> edid.c

gcc -o edid edid.c

./edid > edid.bin

make

./bin2hex edid.bin > edid.hex

